//go:build !ignore_autogenerated
// +build !ignore_autogenerated

/*
Copyright 2021 The Triton Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by controller-gen. DO NOT EDIT.

package v1alpha1

import (
	corev1 "k8s.io/api/core/v1"
	"k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	"k8s.io/apimachinery/pkg/util/intstr"
)

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *ApplicationSpec) DeepCopyInto(out *ApplicationSpec) {
	*out = *in
	if in.Selector != nil {
		in, out := &in.Selector, &out.Selector
		*out = new(v1.LabelSelector)
		(*in).DeepCopyInto(*out)
	}
	in.Template.DeepCopyInto(&out.Template)
	if in.Replicas != nil {
		in, out := &in.Replicas, &out.Replicas
		*out = new(int32)
		**out = **in
	}
	if in.VolumeClaimTemplates != nil {
		in, out := &in.VolumeClaimTemplates, &out.VolumeClaimTemplates
		*out = make([]corev1.PersistentVolumeClaim, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.ApplicationLabel != nil {
		in, out := &in.ApplicationLabel, &out.ApplicationLabel
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new ApplicationSpec.
func (in *ApplicationSpec) DeepCopy() *ApplicationSpec {
	if in == nil {
		return nil
	}
	out := new(ApplicationSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BaseStrategy) DeepCopyInto(out *BaseStrategy) {
	*out = *in
	if in.Paused != nil {
		in, out := &in.Paused, &out.Paused
		*out = new(bool)
		**out = **in
	}
	if in.BatchSize != nil {
		in, out := &in.BatchSize, &out.BatchSize
		*out = new(intstr.IntOrString)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BaseStrategy.
func (in *BaseStrategy) DeepCopy() *BaseStrategy {
	if in == nil {
		return nil
	}
	out := new(BaseStrategy)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *BatchCondition) DeepCopyInto(out *BatchCondition) {
	*out = *in
	if in.Pods != nil {
		in, out := &in.Pods, &out.Pods
		*out = make([]PodInfo, len(*in))
		copy(*out, *in)
	}
	in.StartedAt.DeepCopyInto(&out.StartedAt)
	in.PulledInAt.DeepCopyInto(&out.PulledInAt)
	in.FinishedAt.DeepCopyInto(&out.FinishedAt)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new BatchCondition.
func (in *BatchCondition) DeepCopy() *BatchCondition {
	if in == nil {
		return nil
	}
	out := new(BatchCondition)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DeployFlow) DeepCopyInto(out *DeployFlow) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DeployFlow.
func (in *DeployFlow) DeepCopy() *DeployFlow {
	if in == nil {
		return nil
	}
	out := new(DeployFlow)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *DeployFlow) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DeployFlowList) DeepCopyInto(out *DeployFlowList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]DeployFlow, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DeployFlowList.
func (in *DeployFlowList) DeepCopy() *DeployFlowList {
	if in == nil {
		return nil
	}
	out := new(DeployFlowList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *DeployFlowList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DeployFlowSpec) DeepCopyInto(out *DeployFlowSpec) {
	*out = *in
	if in.Application != nil {
		in, out := &in.Application, &out.Application
		*out = new(ApplicationSpec)
		(*in).DeepCopyInto(*out)
	}
	if in.UpdateStrategy != nil {
		in, out := &in.UpdateStrategy, &out.UpdateStrategy
		*out = new(DeployUpdateStrategy)
		(*in).DeepCopyInto(*out)
	}
	if in.NonUpdateStrategy != nil {
		in, out := &in.NonUpdateStrategy, &out.NonUpdateStrategy
		*out = new(DeployNonUpdateStrategy)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DeployFlowSpec.
func (in *DeployFlowSpec) DeepCopy() *DeployFlowSpec {
	if in == nil {
		return nil
	}
	out := new(DeployFlowSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DeployFlowStatus) DeepCopyInto(out *DeployFlowStatus) {
	*out = *in
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make([]BatchCondition, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Pods != nil {
		in, out := &in.Pods, &out.Pods
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	in.StartedAt.DeepCopyInto(&out.StartedAt)
	in.UpdatedAt.DeepCopyInto(&out.UpdatedAt)
	in.FinishedAt.DeepCopyInto(&out.FinishedAt)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DeployFlowStatus.
func (in *DeployFlowStatus) DeepCopy() *DeployFlowStatus {
	if in == nil {
		return nil
	}
	out := new(DeployFlowStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DeployNonUpdateStrategy) DeepCopyInto(out *DeployNonUpdateStrategy) {
	*out = *in
	in.BaseStrategy.DeepCopyInto(&out.BaseStrategy)
	if in.PodsToDelete != nil {
		in, out := &in.PodsToDelete, &out.PodsToDelete
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DeployNonUpdateStrategy.
func (in *DeployNonUpdateStrategy) DeepCopy() *DeployNonUpdateStrategy {
	if in == nil {
		return nil
	}
	out := new(DeployNonUpdateStrategy)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *DeployUpdateStrategy) DeepCopyInto(out *DeployUpdateStrategy) {
	*out = *in
	in.BaseStrategy.DeepCopyInto(&out.BaseStrategy)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new DeployUpdateStrategy.
func (in *DeployUpdateStrategy) DeepCopy() *DeployUpdateStrategy {
	if in == nil {
		return nil
	}
	out := new(DeployUpdateStrategy)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *PodInfo) DeepCopyInto(out *PodInfo) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new PodInfo.
func (in *PodInfo) DeepCopy() *PodInfo {
	if in == nil {
		return nil
	}
	out := new(PodInfo)
	in.DeepCopyInto(out)
	return out
}
